edira <-
function(A,B,A_ref,B_ref){   
    eccc_pos <- function(pos){
        if(all(nrow(A$data) != nrow(B$data))){stop("A$data and B$data must have the same number of rows.")}            
        y <- as.numeric(A$data[pos,])
        x <- as.numeric(B$data[pos,])
        ymed <- log2(median(2^as.numeric(A$data[pos,])))
        xmed <- log2(median(2^as.numeric(B$data[pos,])))
        ymed_ref <- log2(median(2^as.numeric(A_ref$data[pos,])))
        xmed_ref <- log2(median(2^as.numeric(B_ref$data[pos,])))
        SA <- function(x,xmean){sqrt(sum((x-xmean)^2))}
        eccc <- ((y - ymed_ref)*(x - xmed_ref))/(SA(x,xmed_ref)*SA(y,ymed_ref))
        eccc_var <- ((y - ymed_ref)*(x - xmed_ref))/(SA(x,xmed)*SA(y,ymed))
        eccc_sum <- sum(eccc)
        eccc_var_sum <- sum(eccc_var) 
        test <- wilcox.test(eccc, alternative = "greater")$p.value      
        if(eccc_sum > 0){
            if(ymed > ymed_ref & xmed > xmed_ref | ymed >= ymed_ref & xmed > xmed_ref | ymed > ymed_ref & xmed >= xmed_ref){quadrant <- 1} else {
                if(ymed < ymed_ref & xmed < xmed_ref | ymed <= ymed_ref & xmed < xmed_ref | ymed < ymed_ref & xmed <= xmed_ref){quadrant <- 3} else {quadrant <- sample(c(1,3),1)}
            }            
        } else {
            if(ymed > ymed_ref & xmed < xmed_ref | ymed >= ymed_ref & xmed < xmed_ref | ymed > ymed_ref & xmed <= xmed_ref){quadrant <- 2} else {
                if(ymed < ymed_ref & xmed > xmed_ref | ymed <= ymed_ref & xmed > xmed_ref | ymed < ymed_ref & xmed >= xmed_ref){quadrant <- 4} else {quadrant <- sample(c(2,4),1)}
            }
        } 
    as.data.frame(list(eccc=eccc_sum, eccc_var=eccc_var_sum, test=test, quadrant=quadrant))
    }
  alleWerte <- cbind(t(sapply(1:nrow(A$data),eccc_pos)))
  probier <- apply(alleWerte,2,as.numeric)
  out <- as.data.frame(cbind(A$info, as.data.frame(probier)))
  class(out) <- "edira"
  out
}
